Panda3D

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Public Attributes | List of all members
EggBinner Class Reference

A special binner used only within this package to pre-process the egg tree for the loader and group things together as appropriate. More...

`#include "eggBinner.h"`

Inheritance diagram for EggBinner:

## Public Types
enum | BinNumber { BN_none = 0 , BN_polyset , BN_lod , BN_nurbs_surface , BN_nurbs_curve , BN_patches }

## Public Member Functions
| EggBinner (EggLoader &loader)
virtual std::string | get_bin_name (int bin_number, const EggNode *child)
| May be overridden in derived classes to define a name for each new bin, based on its bin number, and a sample child.
virtual int | get_bin_number (const EggNode *node)
virtual void | prepare_node (EggNode *node)
| May be overridden in derived classes to perform some setup work as each node is encountered.
virtual bool | sorts_less (int bin_number, const EggNode *a, const EggNode *b)
| May be overridden in derived classes to create additional bins within a particular bin number, based on some arbitrary property of nodes.
Public Member Functions inherited from EggBinMaker
virtual bool | collapse_group (const EggGroup *group, int bin_number)
| May be overridden in derived classes to specify whether a particular group node, apparently redundant, may be safely collapsed out.
virtual TypeHandle | force_init_type ()
virtual TypeHandle | get_type () const
int | make_bins (EggGroupNode *root_group)
| The main entry point to EggBinMaker.
virtual | PT (EggBin) make_bin(int bin_number
Public Member Functions inherited from EggObject
| EggObject (const EggObject &copy)
virtual EggTransform * | as_transform ()
| Returns this object cross-cast to an EggTransform pointer, if it inherits from EggTransform, or NULL if it does not.
void | clear_user_data ()
| Removes *all* user data pointers from the node.
void | clear_user_data (TypeHandle type)
| Removes the user data pointer of the indicated type.
EggUserData * | get_user_data () const
| Returns the user data pointer most recently stored on this object, or NULL if nothing was previously stored.
EggUserData * | get_user_data (TypeHandle type) const
| Returns the user data pointer of the indicated type, if it exists, or NULL if it does not.
bool | has_user_data () const
| Returns true if a generic user data pointer has recently been set and not yet cleared, false otherwise.
bool | has_user_data (TypeHandle type) const
| Returns true if the user data pointer of the indicated type has been set, false otherwise.
EggObject & | operator= (const EggObject &copy)
void | set_user_data (EggUserData *user_data)
| Sets the user data associated with this object.
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Public Attributes
EggLoader & | _loader
Public Attributes inherited from EggBinMaker
virtual const EggNode * | child
virtual const EggNode EggGroup * | collapse_from
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Additional Inherited Members
Static Public Member Functions inherited from EggBinMaker
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from EggObject
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Detailed Description

A special binner used only within this package to pre-process the egg tree for the loader and group things together as appropriate.

It is used to collect similar polygons together for a Geom, as well as to group related LOD children together under a single LOD node.

Definition at line 30 of file eggBinner.h.

## Member Enumeration Documentation

## ◆ BinNumber

enum EggBinner::BinNumber

Definition at line 33 of file eggBinner.h.

## Constructor & Destructor Documentation

## ◆ EggBinner()

EggBinner::EggBinner | ( | EggLoader & | loader | ) |

Definition at line 27 of file eggBinner.cxx.

## Member Function Documentation

## ◆ get_bin_name()

std::string EggBinner::get_bin_name | ( | int | bin_number,
|  | const EggNode * | child )
| virtual

May be overridden in derived classes to define a name for each new bin, based on its bin number, and a sample child.

Reimplemented from EggBinMaker.

Definition at line 79 of file eggBinner.cxx.

## ◆ get_bin_number()

int EggBinner::get_bin_number | ( | const EggNode * | node | ) |
| virtual

Implements EggBinMaker.

Definition at line 51 of file eggBinner.cxx.

## ◆ prepare_node()

void EggBinner::prepare_node | ( | EggNode * | node | ) |
| virtual

May be overridden in derived classes to perform some setup work as each node is encountered.

This will be called once for each node in the egg hierarchy.

Reimplemented from EggBinMaker.

Definition at line 38 of file eggBinner.cxx.

References TypedObject::is_of_type(), and EggObject::set_user_data().

## ◆ sorts_less()

bool EggBinner::sorts_less | ( | int | bin_number,
|  | const EggNode * | a,
|  | const EggNode * | b )
| virtual

May be overridden in derived classes to create additional bins within a particular bin number, based on some arbitrary property of nodes.

This function establishes an arbitrary but fixed ordering between nodes; if two nodes do not sort to the same position, different bins are created for each one (with the same bin number on each bin).

Reimplemented from EggBinMaker.

Definition at line 91 of file eggBinner.cxx.

References EggRenderState::compare_to(), EggPrimitive::get_sort_name, and EggObject::get_user_data().

## Member Data Documentation

## ◆ _loader

EggLoader& EggBinner::_loader

Definition at line 56 of file eggBinner.h.

The documentation for this class was generated from the following files:

- panda/src/egg2pg/eggBinner.h
- panda/src/egg2pg/eggBinner.cxx